@use 'breakpoint';
@use 'grid';
@use 'icon';

$padding-list: calc(var(--digi--grid-gutter--smaller) * 1.5) var(--digi--grid-gutter--smaller);

@mixin base {
	font-family: var(--digi--global--typography--font-family--default);
	text-decoration: none;
	color: var(--digi--color--text--secondary);
	font-size: var(--digi--global--typography--font-size--large);
	letter-spacing: calc(var(--digi--global--typography--font-size--large) / 100 * -1);
	font-weight: var(--digi--global--typography--font-weight--semibold);

	&:hover {
		color: var(--digi--global--color--profile--purple--dark);
		text-decoration: underline;
	}

	&:focus {
		outline: none;
		color: var(--digi--color--text--secondary);
	}

	&:focus-visible {
		outline: var(--digi--border-width--secondary) solid var(--digi--color--border--focus);
	}

	&:visited {
		color: var(--digi--color--text--secondary);
	}
}

@mixin list {
	@include base;

	display: block;
	border-radius: var(--digi--border-radius--primary);
	padding: $padding-list;

	&::after {
		@include icon.mask-pseudo;
	}
}

@mixin card {
	@include base;

	@include breakpoint.medium {
		font-size: var(--digi--global--typography--font-size--larger);
		letter-spacing: calc(var(--digi--global--typography--font-size--larger) / 100 * -1);
		line-height: 1.44;
	}

	&:hover {
		color: var(--digi--global--color--profile--purple--dark);
		text-decoration: underline;
	}

	&::after {
		@include icon.mask-pseudo;

		mask-size: cover;
	}
}

@mixin icon {
	@include base;

	font-weight: var(--digi--global--typography--font-weight--regular);
	display: inline-flex;
	letter-spacing: unset;
	flex-direction: row;
	align-items: center;
	font-size: var(--digi--global--typography--font-size--smaller);
	gap: 0.5em;

	@include breakpoint.large {
		gap: 0;
		font-size: 0.75rem;
		flex-direction: column;
		justify-content: center;
		line-height: 1;
	}
}

@mixin menu($active: false) {
	@include base;

	--digi--link--menu--color: var(--digi--color--text--secondary);
	font-size: var(--digi--global--typography--font-size--large);

	@include breakpoint.large {
		--digi--link--menu--color: var(--digi--color--text--inverted);

		font-size: var(--digi--global--typography--font-size--small);
	}

	font-weight: var(--digi--global--typography--font-weight--regular);

	@include breakpoint.below-large {
		display: flex;
		justify-content: space-between;
		text-align: start;
		align-items: center;
	}

	@include breakpoint.large {
		display: block;
	}

	color: var(--digi--link--menu--color);

	&:hover {
		color: var(--digi--link--menu--color);
		text-decoration: underline;
	}

	&:focus,
	&:focus-visible,
	&:active {
		color: var(--digi--link--menu--color);
	}

	&:focus-visible {
		z-index: 1;
	}

	&:visited {
		color: var(--digi--link--menu--color);
	}

	&::after {
		@include icon.mask-pseudo('chevron-right');

		@include breakpoint.below-large {
			height: 100%;
		}

		@include breakpoint.large {
			@include icon.mask-pseudo(if($active, 'chevron-up', 'chevron-down'));
		}
	}
}
